import { ChangeDetectorRef, DoCheck, ElementRef, EventEmitter, KeyValueDiffers } from '@angular/core';
import { ScrollbarHelper } from '../../../services/scrollbar-helper.service';
import { DatatableAction, EventQuickEditRow } from '../../../types/table-row.type';
import { DatatableService } from '../../../types/table-service.type';
import { DatatableRow, TreeStatus } from '../body-cell/body-cell.component';
import * as i0 from "@angular/core";
export declare class DataTableBodyRowComponent<T> implements DoCheck {
    private differs;
    private scrollbarHelper;
    private cd;
    get isHover(): boolean;
    mouseover(): void;
    mouseleave(): void;
    set actions(actions: DatatableAction<T>[]);
    get actions(): DatatableAction<T>[];
    /**
     * Danh sách thao tác
     */
    private _actions;
    /**
     * Thao tác mở rộng
     */
    _lstExpandAction: DatatableAction<T>[];
    /**
     * Giữ giá trị khi người dùng nhấn action
     */
    private actionRow;
    /**
     * Lưu giá trị edit
     */
    private tempQuickEditRow;
    get quickEditRow(): DatatableRow<T>;
    set quickEditRow(row: DatatableRow<T>);
    isLoadingQuickEditRow: boolean;
    rows: Array<DatatableRow<T>>;
    datatableService: DatatableService<T>;
    delete: EventEmitter<T>;
    quickEdit: EventEmitter<EventQuickEditRow<T>>;
    set columns(val: any[]);
    get columns(): any[];
    set innerWidth(val: number);
    get innerWidth(): number;
    expanded: boolean;
    rowClass: any;
    row: DatatableRow<T>;
    group: any;
    isSelected: boolean;
    rowIndex: number;
    displayCheck: any;
    treeStatus: TreeStatus;
    set offsetX(val: number);
    get offsetX(): number;
    get cssClass(): string;
    rowHeight: number;
    get columnsTotalWidths(): string;
    activate: EventEmitter<any>;
    treeAction: EventEmitter<any>;
    _element: any;
    _columnGroupWidths: any;
    _columnsByPin: any;
    _offsetX: number;
    _columns: any[];
    _innerWidth: number;
    _groupStyles: {
        [prop: string]: {};
    };
    private _rowDiffer;
    constructor(differs: KeyValueDiffers, scrollbarHelper: ScrollbarHelper, cd: ChangeDetectorRef, element: ElementRef);
    ngDoCheck(): void;
    trackByGroups(index: number, colGroup: any): any;
    columnTrackingFn(index: number, column: any): any;
    buildStylesByGroup(): void;
    calcStylesByGroup(group: string): {
        width: string;
    };
    onActivate(event: any, index: number): void;
    onKeyDown(event: KeyboardEvent): void;
    onMouseenter(event: any): void;
    recalculateColumns(val?: any[]): void;
    onTreeAction(): void;
    rowClick(action: DatatableAction<T>, row: DatatableRow<T>): void;
    getRowPrimaryValue(row: DatatableRow<T>): DatatableRow<T>[keyof T];
    private subcriberEdit;
    isRowEdit(): boolean;
    saveEdit(): Promise<void>;
    cancelEdit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableBodyRowComponent<any>, [null, { skipSelf: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DataTableBodyRowComponent<any>, "datatable-body-row", never, { "actions": "actions"; "rows": "rows"; "datatableService": "datatableService"; "columns": "columns"; "innerWidth": "innerWidth"; "expanded": "expanded"; "rowClass": "rowClass"; "row": "row"; "group": "group"; "isSelected": "isSelected"; "rowIndex": "rowIndex"; "displayCheck": "displayCheck"; "treeStatus": "treeStatus"; "offsetX": "offsetX"; "rowHeight": "rowHeight"; }, { "delete": "delete"; "quickEdit": "quickEdit"; "activate": "activate"; "treeAction": "treeAction"; }, never, never, false>;
}
